<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv.menu");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="default" >
<base:head
	scripts="~../labenv.js,~labenvironmentalarms.js"
	styles="path.css,table.css,~../css/labenv.css"
	>
<style>
#alarms div.data > table
{
	border-left: 0;
	border-right: 0;
}
#alarms div.data > table td
{
	padding: 3px;
}

#alarms div.data > table td.id-col, #alarms div.data > table th.id-col
{
	text-align: right;
	width: 3em;
	padding-right: 0.5em;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement title="Lab sensor alarms" /></p:path>

	<div class="content wizard" id="wizard">

		<tbl:table id="alarms" style="display: none;">
			<tbl:columndef 
				id="alarmId"
				title="##"
				subclass="id-col"
			/>
			<tbl:columndef 
				id="sensorName"
				title="Sensor"
			/>
			<tbl:columndef 
				id="url"
				title="URL"
			/>
			<tbl:columndef
				id="startTime"
				title="Start time"
			/>
			<tbl:columndef 
				id="endTime"
				title="End time"
			/>
			<tbl:columndef 
				id="weekdayFilter"
				title="Weekday"
			/>
			<tbl:columndef 
				id="minTemp"
				title="Min"
			/>
			<tbl:columndef 
				id="maxTemp"
				title="Max"
			/>
			<tbl:columndef 
				id="minHumidity"
				title="Min"
			/>
			<tbl:columndef 
				id="maxHumidity"
				title="Max"
			/>
			<tbl:columndef 
				id="blocked"
				title="Blocked"
			/>
			<tbl:columndef 
				id="alarmText"
				title="Alarm"
			/>
			<tbl:data style="border-right: 0; border-left: 0;">
				<tbl:headers>
					<tbl:headerrow>
						<th></th>
						<th></th>
						<th></th>
						<th colspan="3">Filter</th>
						<th colspan="2">Temperature</th>
						<th colspan="2">Humidity</th>
						<th></th>
						<th></th>
					</tbl:headerrow>
					<tbl:headerrow id="row-template">
						<tbl:columnheaders />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows id="all-rows">					
				</tbl:rows>
			</tbl:data>
		</tbl:table>

		<div id="wizard-status"></div>

		<table class="navigation" id="navigation">
		<tr>
			<td><base:button id="gosetalarmblocker" title="Set alarm blocker" image="<%=home + "/images/gonext.png"%>" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		</tr>
		</table>

	</div>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>