<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="default" >
<base:head
	scripts="~../labenv.js,~labenvironmentdatabasedisplay.js,~boxplot.js"
	styles="path.css,~../css/labenv.css,~../css/report.css"
	>
	
	<style>
	canvas
	{
		width: 700px;
		height: 550px;
	}
	.guide
	{
		position: absolute;
		z-index: 99;
		display: none;
		background-color: #224488;
	}
	</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="LabEnv" href="<%="./labenvironmentdatabasedisplay.jsp?ID="+ID%>" 
			/><p:pathelement title="Lab environment display" 
			/></p:path>
		<div id="x-guide" class="guide" style="width: 1px;"></div>
		<div id="y-guide" class="guide" style="height: 1px;"></div>
		<div class="content">
		<form name="labenv" id="wizard" class="wizard">

			<!-- 1. Report type-->
			<div class="step" id="step-1">
				<div class="step-no">1</div>
				<div class="step-title">Report type</div>
				<div class="step-content">
	
					<table class="step-form">
					<tr>
						<td class="prompt">Report</td>
						<td class="input">
							<select name="reporttype" style="width: 20em">
								<option value="labenvironmentdailydisplay" selected="yes">Daily display</option>
								<option value="labenvironmentweeklydisplay">Weekly display</option>
								<option value="labenvironmentoverviewdisplay">Overview display</option>
							</select>
						</td>
						<td class="status" id="report.status"></td>
						<td class="help">
							<span id="report.message" class="message"></span>
							Select which report to generate.
						</td>
					</tr>
					</table>
				</div>
			</div>
			
			<div id="parameterSection" style="display:none;">
				<p></p>
				<!-- 2. Report parameters-->
				<div class="step" id="step-2">
					<div class="step-no">2</div>
					<div class="step-title">Report parameters</div>
					<div class="step-content">
	
						<table class="step-form">
						<tr>
							<td valign="top" class="prompt">
								<div id="reportPeriodSubSection01" style="display:none;">
									<text id="reportPeriodSubSection01Header">From</text>
								</div>
							</td>
							<td valign="top" class="input">
								<div id="reportPeriodSubSection02" style="display:none;">
									Date <input type="text" name="fromdate" value=""
										style="width: 10em" maxlength="10"
										data-auto-init="focus-on-enter" data-next-focus="chartvariant"
									>
								</div>
							</td>
							<td valign="top" class="status" id="sensorSelect.status"></td>
							<td class="help">
								<div id="reportPeriodSubSection04" style="display:none;">
									<span id="sensorSelect.message" class="message" style="display: none;"></span>
									<text id="reportPeriodSubSection04HelpText">Select sensor(s)</text><br>
								</div>
							</td>
						</tr>	
						<tr>
							<td valign="top" class="prompt">
								<div id="dayTimeFilterSubSection01" style="display:none;">
									Daytime filter
								</div>
							</td>
							<td valign="top" class="input">
								<div id="dayTimeFilterSubSection02" style="display:none;">
									From time <input type="text" name="filterfromtime" value=""
										style="width: 4em" maxlength="4" 
										data-auto-init="focus-on-enter" data-next-focus="filtertotime"
									>
									To time <input type="text" name="filtertotime" value=""
										style="width: 4em" maxlength="4" 
										data-auto-init="focus-on-enter" data-next-focus="weekdayfilter"
									>
								</div>
							</td>
							<td valign="top" class="status" id="dayTimeFilter.status"></td>
							<td class="help">
								<div id="dayTimeFilterSubSection04" style="display:none;">
									<span id="dayTimeFilter.message" class="message" style="display: none;"></span>
									Select what daytime interval to include in statistics (HHMM). Note that climate control in some labs are only active during day. Blank fields give data for full day.
								</div>
							</td>
						</tr>
						<tr>
							<td valign="top" class="prompt">
								<div id="weekDayFilterSubSection01" style="display:none;">
									Week day filter
								</div>
							</td>
							<td valign="top" class="input">
								<div id="weekDayFilterSubSection02" style="display:none;">
									<select id="weekDayFilterSelectId" name="weekdayfilter" style="width: 15em">
										<option value="all">All</option>
										<option value="mondaytofriday">Mon-Fri only</option>
										<option value="saturdaytosunday">Sat-Sun only</option>
										<option value="workdays" selected="yes">Workdays</option>
										<option value="nonworkdays">Non-workdays</option>
									</select>
								</div>
							</td>
							<td valign="top" class="status" id="weekDayFilter.status"></td>
							<td class="help">
								<div id="weekDayFilterSubSection04" style="display:none;">
									<span id="weekDayFilter.message" class="message" style="display: none;"></span>
									Select what weekdays to include in statistics. Note that climate control in some labs are shut down on non-workdays (Saturdays, Sundays and work-free days related to holidays).
								</div>
							</td>
						</tr>
						<tr>
							<td valign="top" class="prompt">
								<div id="chartVariantSubSection01" style="display:none;">
									Chart data
								</div>
							</td>
							<td valign="top" class="input">
								<div id="chartVariantSubSection02" style="display:none;">
									<select id="sensorSelectId" name="chartvariant" style="width: 20em">
										<option value="all">All</option>
									</select>
								</div>
							</td>
							<td valign="top" class="status" id="displaychartVariant.status"></td>
							<td class="help">
								<div id="chartVariantSubSection04" style="display:none;">
									<span id="displaychartVariant.message" class="message" style="display: none;"></span>
									Select what data to report.
								</div>
							</td>
						</tr>
						</table>
					</div>
				</div>
			</div>
			
			<div class="step" id="step-3">
				<div class="step-no">3</div>
				<div class="step-title">Generated report
					<span id="printButton" class="link"><img src="../images/print.png">Print version&hellip;</span>
				</div>
				<div class="step-content" id="step-3-content">
					<div id="reportdiv" style="text-align: center;"></div>
				</div>
			</div>
					
			<div id="wizard-status"></div>
			
			<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>		
				
			<table class="navigation" id="navigation">
				<tr>
					<td><base:button id="gocancel" title="Cancel" /></td>
					<td><base:button id="gonext" title="Next" image="<%="gonext.png"%>" /></td>
					<td><base:button id="gocreate" title="Generate" image="<%="gonext.png"%>" /></td>					
					<td><base:button id="gorestart" title="Restart" image="<%="goback.png"%>" /></td>
					<td id="gonext.message" class="message"></td>
				</tr>
			</table>			
		</form>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>