var LabEnvDbEvPopup = function()
{
	var labenvdbevpopup = {};
	var debug = 0;
	var storageIntervalInSeconds = null;
	var intervalIsValid = true;

	labenvdbevpopup.getStorageIntervalInSeconds = function()
	{
		return storageIntervalInSeconds;
	}

	labenvdbevpopup.setStorageIntervalInSeconds = function(storageIntervalInSecondsInput)
	{
		storageIntervalInSeconds = storageIntervalInSecondsInput;
	}

	// Page initialization
	labenvdbevpopup.initPage = function()
	{
		var frm = document.forms['labenv'];

		// Step 1
		Events.addEventHandler('goprint', 'click', labenvdbevpopup.printVersion);

		// Navigation
		Buttons.addClickHandler('goprint', labenvdbevpopup.printVersion);
		Buttons.addClickHandler('gocancel', labenvdbevpopup.cancelPrint);

		// Fetch and store storage interval in seconds
		labenvdbevpopup.fetchStorageIntervalInSeconds();

		// Create pop-up window from request parameter data
		labenvdbevpopup.goCreate();
	};

	labenvdbevpopup.fetchStorageIntervalInSeconds = function()
	{
		// Get lab environment database configuration JSON object with AJAX
		var request = Ajax.getXmlHttpRequest();
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLabEnvDatabaseConfig';

		Wizard.asyncJsonRequest(url, labenvdbevpopup.fetchStorageIntervalInSeconds2);
	}

	labenvdbevpopup.fetchStorageIntervalInSeconds2 = function(response)
	{
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		// Get lab environment database configuration information from the AJAX response
		var labEnvDatabaseConfig = response.labEnvDatabaseConfig;
		if (labEnvDatabaseConfig != null)
		{
			var storageIntervalInSecondsCurrent = labEnvDatabaseConfig.storageIntervalInSeconds;
			labenvdbevpopup.setStorageIntervalInSeconds(storageIntervalInSecondsCurrent);
		}
	}

	labenvdbevpopup.getQueryParameter = function(parameterName)
	{
		var queryString = window.top.location.search.substring(1);
		var parameterName = parameterName + "=";
		if ( queryString.length > 0 )
		{
			begin = queryString.indexOf(parameterName);
			if (begin != -1)
			{
				begin += parameterName.length;
				end = queryString.indexOf("&" , begin);
				if (end == -1)
				{
					end = queryString.length;
				}
				return unescape(queryString.substring(begin, end));
			}
		}
		return null;
	}

	function getStorageIntervalInSeconds()
	{
		var storageIntervalInSeconds = 0;
		var labEnvDatabaseConfig = getLabEnvDatabaseConfig();
		if (labEnvDatabaseConfig != null)
		{
			storageIntervalInSeconds = labEnvDatabaseConfig.storageIntervalInSeconds;
		}
		return storageIntervalInSeconds;
	}

	function getLabEnvDatabaseConfig()
	{
		// Get lab environment database configuration JSON object with AJAX
		var frm = document.forms['labenv'];
		var request = Ajax.getXmlHttpRequest();
		var url = '../../labenv.jar/LabEnvironment.servlet?ID='+App.getSessionId()+'&cmd=GetLabEnvDatabaseConfig';
		request.open("GET", url, false); 
		request.send(null);
	
		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
	
		// Get lab environment database configuration information from the AJAX response
		var labEnvDatabaseConfig = response.labEnvDatabaseConfig;

		return labEnvDatabaseConfig;
	}

	labenvdbevpopup.addEventHandlers = function(elements, eventName, handler)
	{
		for (var i = 0; i < elements.length; i++)
		{
			Events.addEventHandler(elements[i], eventName, handler);
		}
	}

	labenvdbevpopup.fetchSimpleDate = function(dateStr)
	{
		var simpleDateStr = dateStr;
		if (simpleDateStr != null)
		{
			var blankIndex = simpleDateStr.indexOf(" ");
			if (blankIndex >= 0)
			{
				// YYYYMMDD HHmm or YYYY-MM-DD HH:mm
				// Cut off date string before first space
				simpleDateStr = simpleDateStr.substr(0,blankIndex);
			}
			//alert("simpleDateStr = \"" + simpleDateStr + "\" after removing daytime");
			// YYYYMMDD or YYYY-MM-DD
			var hyphenIndex = simpleDateStr.indexOf("-");
			//alert("simpleDateStr = \"" + simpleDateStr + "\" after removing daytime, hyphenIndex = " + hyphenIndex);
			if (hyphenIndex >= 0)
			{
				// YYYY-MM-DD
				// Cut off date string before first space
				var yearStr = simpleDateStr.substr(0,4);
				var monthStr = simpleDateStr.substr(5,2);
				var dayStr = simpleDateStr.substr(8,2);
				simpleDateStr = yearStr + monthStr + dayStr;
				//alert("simpleDateStr = \"" + simpleDateStr + "\" after removing hyphens, yearStr = \"" + yearStr + "\" monthStr = \"" + monthStr + "\" dayStr = \"" + dayStr + "\"");
			}
		}
		// Date in YYYYMMDD format
		return simpleDateStr;
	}

	labenvdbevpopup.goCreate = function()
	{
		if (!intervalIsValid) return;
		var frm = document.forms['labenv'];		
		var reportType = labenvdbevpopup.getQueryParameter('reportType') || 'labenvironmentdailydisplay';
		var url = '../LabEnvironmentDisplay.servlet?ID='+App.getSessionId()+'&cmd='+reportType;		
		var fromDate = null;
		var chartVariant = null;
		if (chartVariant == null)
		{
			chartVariant = 'http://givare1.onk.lu.se/';
		}
		var pageTitle = labenvdbevpopup.getQueryParameter('pageTitle');
		var labSensorUrl = labenvdbevpopup.getQueryParameter('labSensorUrl');
		var originDate = labenvdbevpopup.getQueryParameter('originDate');
		originDate = labenvdbevpopup.fetchSimpleDate(originDate);
		if (originDate != null)
		{
			fromDate = originDate;
		}
		if (labSensorUrl != null)
		{
			chartVariant = labSensorUrl;
		}
		if (pageTitle != null) url += '&pagetitle='+pageTitle;
		if (fromDate != null) url += '&fdate='+fromDate;
		if (chartVariant != null) url += '&cvariant='+chartVariant;

		Wizard.showLoadingAnimation('Generating plots...');
		Wizard.asyncJsonRequest(url, labenvdbevpopup.onPlotGenerated);
	}
	
	labenvdbevpopup.onPlotGenerated = function(response)
	{
		Doc.show('reportSection');
		var frm = document.forms['labenv'];		
		var reportType = 'labenvironmentdailydisplay';
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		var report = response.report;
		var permissionDeniedForPatientName = report.permissionDeniedForPatientName;
		var pageTitle = report.pageTitle;
		if (pageTitle == null || pageTitle == '')
		{
			pageTitle = 'LabEnv';
		}
		// Print optional page title
		var pageTitleElement = document.getElementById('pageTitleId');
		pageTitleElement.innerHTML = pageTitle;
		var reportTable;
		var cellElement = document.getElementById('reportdiv');
		if (report != null)
		{
			var storageIntervalInSeconds = labenvdbevpopup.getStorageIntervalInSeconds();
			var draw_area_wdt = parseInt(labenvdbevpopup.getQueryParameter('plotWidth')) || 700;
			var draw_area_hgt = parseInt(labenvdbevpopup.getQueryParameter('plotHeight')) || 550;
			var draw_scale_factor = 2;
			var jsonStatisticsPlotArray = report.plotStatistics;
			// Draw plots
			document.getElementById("reportdiv").innerHTML="";
			// Write optional page header
			if (pageTitle != null && pageTitle != '')
			{
				// Print optional page headline
				var headlineText = document.createElement('text');
				headlineText.innerHTML = "<h2>" + pageTitle + "</h2><BR>";
				cellElement.appendChild(headlineText);
			}
			var originDate = labenvdbevpopup.getQueryParameter('originDate') || Dates.formatDate(new Date());
			for (var plotIndex in jsonStatisticsPlotArray)
			{
				//
				// Get plot JSON data container with extra info and plot data
				var plotJsonDataContainer = jsonStatisticsPlotArray[plotIndex];
				// Get plot JSON extra info and plot data
				var plotChartVariant = plotJsonDataContainer['chartVariant'];
				var plotViewType = plotJsonDataContainer['viewType'];
				var plotOptionalHeadline = plotJsonDataContainer['optionalHeadline'];
				var boxPlotJsonData = plotJsonDataContainer['plotData'];
				// Create plot from plot JSON data
				if (plotOptionalHeadline != null && plotOptionalHeadline != '')
				{
					// Print optional headline
					var headlineText = document.createElement('text');
					headlineText.innerHTML = "<BR>" + plotOptionalHeadline + "<BR>";
					cellElement.appendChild(headlineText);
				}
				var plotKey = plotChartVariant + '_' + plotViewType;
				// Add plot
				var canvasInTable = document.createElement('canvas');
				canvasInTable.setAttribute('id', plotKey);
				canvasInTable.setAttribute('width', draw_area_wdt * draw_scale_factor);
				canvasInTable.setAttribute('height', draw_area_hgt * draw_scale_factor);
				canvasInTable.style.width = (draw_area_wdt)+'px';
				canvasInTable.style.height = (draw_area_hgt)+'px';
				boxPlotJsonData.titleTop = originDate;
				createGraphPlot(boxPlotJsonData, canvasInTable, draw_area_wdt, draw_area_hgt, draw_scale_factor, plotViewType, storageIntervalInSeconds);
				cellElement.appendChild(canvasInTable);					
				canvasInTable.addEventListener('mousemove', labenvdbevpopup.drawCanvasGuidelines, false);
				canvasInTable.addEventListener('mouseleave', labenvdbevpopup.hideCanvasGuidelines, false);
			}
			// Print optional appended info
			var appendedInfo = report.appendedInfo;
			if (appendedInfo != null && appendedInfo != '')
			{
				// Print optional headline
				var infoText = document.createElement('text');
				infoText.innerHTML = "<BR>" + appendedInfo + "<BR>";
				cellElement.appendChild(infoText);
			}
		}
		else
		{
			var messageCell = getTableCellElement(document, 'No values could be found during given period', 'reportheader');
			var messageRow = document.createElement('tr');
			messageRow.appendChild(messageCell);			
			var messageTable = getReportTable();
			messageTable.appendChild(messageRow);
			reportTable = messageTable;			
		}
		Doc.show('goprint');
		Doc.show('gorestart');		
	}

	labenvdbevpopup.getReportTable = function()
	{
			var reportTable = document.createElement('table');
			reportTable.setAttribute('class','reporttable');
			reportTable.setAttribute('border','1');			
			return reportTable;
	}
	
	labenvdbevpopup.getTableCellElement = function(topDocument, text, clazz, colspan, rowspan)
	{
		if (topDocument != null)
		{
			cellElement = topDocument.createElement('td');
		}
		var cellElement = topDocument.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(topDocument.createElement('br'));
				cellElement.appendChild(topDocument.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(topDocument.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}
	
	var xGuide;
	var yGuide;
	
	labenvdbevpopup.drawCanvasGuidelines = function(event)
	{
		if (!xGuide)
		{
			xGuide = document.getElementById('x-guide');
			yGuide = document.getElementById('y-guide');
		}
		var canvas = event.target;
		var centerX = event.clientX;
		var centerY = event.clientY;
		var canvasPos = Doc.getElementPosition(canvas);
		var startX = canvasPos.left+60;
		var widthX = canvasPos.width-120;
		var startY = canvasPos.top+65;
		var heightY = canvasPos.height-120;
		if (centerY < startY || centerY > startY+heightY)
		{
			// Hide when mouse is in the text area below or over the plot
			yGuide.style.display = 'none';
		}
		else
		{
			yGuide.style.top = (centerY-2) + 'px';
			yGuide.style.left = startX + 'px';
			yGuide.style.width = widthX + 'px';
			yGuide.style.display = 'block';
		}
		if (centerX < startX || centerX > startX + widthX)
		{
			// Hide when mouse is in the text area to the left or right of the plot
			xGuide.style.display = 'none';
		}
		else
		{
			// Avoid drawing outside the avilable height (causes an extra pair of scroll bars)
			var yLimit = App.getWindowPosition().height;
			if (startY+heightY > yLimit)
			{
				heightY = yLimit-startY;
			}
			xGuide.style.top = startY + 'px';
			xGuide.style.left = (centerX-2) + 'px';
			xGuide.style.height = heightY + 'px';
			xGuide.style.display = 'block';
		}

	}
	
	labenvdbevpopup.hideCanvasGuidelines = function(event)
	{
		xGuide.style.display = 'none';
		yGuide.style.display = 'none';
	}
	
	labenvdbevpopup.printVersion = function()
	{
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.';
		printNote += ' Scale down to <i>90%</i> to fit 2 plots per page.';
		LabEnv.openPrintWindow('reportcell', 'Lab environment ', 'portrait', printNote, '../', 'report.css');
	}

	labenvdbevpopup.cancelPrint = function()
	{
		window.close();
	}
	
	return labenvdbevpopup;
}();

Doc.onLoad(LabEnvDbEvPopup.initPage);
	