<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="java.util.Calendar"
	import="java.util.Locale"
	import="java.text.SimpleDateFormat"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head
	scripts="~../labenv.js,~labenvironmentdatabaseexport.js"
	styles="path.css,~../css/labenv.css"
	>
	<link rel="stylesheet" type="text/css" href="../css/labenv.css">
<style>

.fullyear
{
	font-weight: bold;
}

#previewWrapper
{
	position: absolute;
	//top: 11em;
	top: 15em;
	bottom: 1em;
	left: 20px;
	width: 950px;
	overflow: visible;
}

#previewList
{
	position: absolute;
	top: 1.5em;
	bottom: 0px;
	width: 950px;
	overflow: auto;
	white-space: pre; 
	font-family: monospace;
	border: 1px dotted #A0A0A0;
	border-radius: 4px;
	background: #E8E8E8;
	padding: 0.25em;
}

#previewTitle
{
	font-weight: bold;
}

#previewList th
{
	border-bottom: 1px dotted #A0A0A0;
}

#previewList td, #previewList th
{
	text-align: left;
	padding-right: 2em;
	vertical-align: bottom;
}

</style>
</base:head>
<base:body >

	<p:path><p:pathelement 
		title="LabEnv" href="<%="./labenvironmentdatabaseexport.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab environment database export" 
		/></p:path>

	<div class="content">
	<form name="labenv" id="wizard" class="wizard">
	
	<!-- 1. Select lab sensor -->
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select lab sensor(s) and time period</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Sensor</td>
				<td class="input">
					<select id="sensorSelectId" name="sensorSelect" style="width: 20em">
						<option value="all">All</option>
					</select>
				</td>
				<td class="status" id="sensorSelect.status"></td>
				<td class="help">
					<span id="sensor.message" class="message"></span>
				</td>
			</tr>			
			<tr id="fromDateTimeSection" valign="top">
				<td class="prompt">From</td>
				<td class="input">
					Date <input type="text" name="fromDate" value=""
						style="width: 10em" maxlength="10" 
						data-auto-init="focus-on-enter" data-next-focus="fromTime"
					>
					Time <input type="text" name="fromTime" value=""
						style="width: 4em" maxlength="4" 
						data-auto-init="focus-on-enter" data-next-focus="toDate"
					>
				</td>
				<td class="status" id="fromDateTime.status"></td>
				<td class="help">
					<span id="fromDateTime.message" class="message"></span>
					Start date+time (YYYYMMDD, HHMM) Blank fields give data from start
				</td>
			</tr>
			<tr id="toDateTimeSection" valign="top">
				<td class="prompt">To</td>
				<td class="input">
					Date <input type="text" name="toDate" value=""
						style="width: 10em" maxlength="10"
						data-auto-init="focus-on-enter" data-next-focus="toTime"
					>
					Time <input type="text" name="toTime" value=""
						style="width: 4em" maxlength="4"
						data-auto-init="focus-on-enter" data-next-focus="displayIndexSelectId"
					>
				</td>
				<td class="status" id="toDateTime.status"></td>
				<td class="help">
					<span id="toDateTime.message" class="message"></span>
					End date+time (YYYYMMDD, HHMM) Blank fields give data to end
				</td>
			</tr>
			<tr id="displayIndexSection" valign="top">
				<td class="prompt">Display index values</td>
				<td class="input">
					<select id="displayIndexSelectId" name="displayIndexSelect" style="width: 4em">
						<option value="true">Yes</option>
						<option value="false" selected="yes">No</option>
					</select>
				</td>
				<td class="status" id="displayIndex.status"></td>
				<td class="help">
					<span id="displayIndex.message" class="message"></span>
					Select if database indices should be displayed
				</td>
			</tr>
			</table>
		</div>
	</div>

	<div id="wizard-status"></div>

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gopreview" title="Preview" image="<%="export.png"%>" /></td>
		<td><base:button id="goexport" title="Download" image="<%="download.png"%>" /></td>
	</tr>
	</table>
	</form>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div id="previewWrapper" style="display: none;">
		<div>
			<span id="previewTitle">Preview</span>
			<span id="previewWarning"></span>
		</div>
		<div id="previewList"></div>
	</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>