var LabSensInf = function()
{
	var labsensinf = {};
	var debug = 1;

	// Page initialization
	labsensinf.initPage = function()
	{
		labsensinf.getSensorInfo();
	}

	labsensinf.getSensorInfo = function()
	{
		var url = '../LabEnvironment.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSensorInfo';
		Wizard.showLoadingAnimation('Loading sensor information. Please wait...');
		Wizard.asyncJsonRequest(url, labsensinf.onSensorInfoLoaded);
	}
		
	labsensinf.onSensorInfoLoaded = function(response)
	{
		var template = Doc.element('row-template');
		var cols = template.getElementsByTagName('th');
		var rows = Doc.element('all-rows');
		
		var sensors = response.sensors;
		for (var sensorNo = 0; sensorNo < sensors.length; sensorNo++)
		{
			var sensor = sensors[sensorNo];
			
			var row = document.createElement('tr');
			row.className = sensorNo % 2 == 0 ? 'evenrow highlight' : 'oddrow highlight';
			
			for (var colNo = 0; colNo < cols.length; colNo++)
			{
				var cell = document.createElement('td');
				cell.className = 'cell';
				var colId = cols[colNo].id;
				if (colId == 'sensors.sensorId')
				{
					cell.className = 'id-col';
					cell.innerHTML = sensor.id;
				}
				else if (colId == 'sensors.sensorName')
				{
					cell.innerHTML = Strings.encodeTags(sensor.name);
				}
				else if (colId == 'sensors.url')
				{
					cell.innerHTML = '<a href="'+Strings.encodeTags(sensor.url)+'" target="_blank" rel="noopener noreferrer">'+Strings.encodeTags(sensor.url)+'</a>';
				}
				else if (colId == 'sensors.serial')
				{
					cell.innerHTML = Strings.encodeTags(sensor.serial);
				}
				else if (colId == 'sensors.time')
				{
					cell.innerHTML = Strings.encodeTags(sensor.time);
				}
				else if (colId == 'sensors.temperature')
				{
					cell.innerHTML = Numbers.formatNumber(sensor.temperature, 1);
				}
				else if (colId == 'sensors.humidity')
				{
					cell.innerHTML = Numbers.formatNumber(sensor.humidity, 1);
				}
				else if (colId == 'sensors.alarm')
				{
					var html = '';
					if (sensor.alarms && sensor.alarms.length > 0)
					{
						html += '<ul>';
						for (var alarmNo = 0; alarmNo < sensor.alarms.length; alarmNo++)
						{
							html += '<li>'+Strings.encodeTags(sensor.alarms[alarmNo]);
						}
						html += '</ul>';
					}
					cell.innerHTML = html;
				}
				else if (colId == 'sensors.actions')
				{
					if (sensor.active)
					{
						var html = '<span class="link daily-plot"';
						html += ' data-sensor-url="'+Strings.encodeTags(sensor.url)+'"';
						html += ' data-sensor-name="'+Strings.encodeTags(sensor.name)+'"';
						html += '><img src="../images/chart_curve.png"> Last 24 hours</span>';
						cell.innerHTML = html;
					}
				}
				row.appendChild(cell);
			}
			rows.appendChild(row);
		}
		
		var dailyPlots = document.getElementsByClassName('daily-plot');
		for (var itemNo = 0; itemNo < dailyPlots.length; itemNo++)
		{
			Events.addEventHandler(dailyPlots[itemNo], 'click', labsensinf.dailyPlot);
		}

		Doc.show('sensors');
	}

	
	labsensinf.dailyPlot = function(event)
	{
		
		var url = 'labenvironmentdatabaseeventpopup.jsp?ID='+App.getSessionId();
		url += '&plotWidth=480&plotHeight=360&reportType=last24hours';
		url += '&labSensorUrl='+encodeURIComponent(Data.get(event.currentTarget, "sensor-url"));
		url += '&pageTitle='+encodeURIComponent(Data.get(event.currentTarget, "sensor-name"));
		
		Dialogs.openPopup(url, 'test', 1000, 500);
	}

	
	return labsensinf;
}();

Doc.onLoad(LabSensInf.initPage);
