<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../labenv.js,~labsensorinfo.js" 
	styles="path.css,table.css,~../css/labenv.css"
	>
<style>

#sensors div.data > table
{
	border-left: 0;
	border-right: 0;
}
#sensors div.data > table td
{
	padding: 3px;
}

#sensors div.data > table td.id-col, #sensors div.data > table th.id-col
{
	text-align: right;
	width: 3em;
	padding-right: 0.5em;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement title="Lab sensor info" /></p:path>

	<div class="content" id="wizard">
		<tbl:table id="sensors" style="display: none;">
			<tbl:columndef 
				id="sensorId"
				title="##"
				subclass="id-col"
			/>
			<tbl:columndef 
				id="sensorName"
				title="Sensor"
			/>
			<tbl:columndef 
				id="url"
				title="URL"
			/>
			<tbl:columndef
				id="serial"
				title="Serial Number"
			/>
			<tbl:columndef 
				id="time"
				title="Time"
			/>
			<tbl:columndef 
				id="temperature"
				title="Temp (°C)"
			/>
			<tbl:columndef 
				id="humidity"
				title="Humidity (%)"
			/>
			<tbl:columndef 
				id="alarm"
				title="Alarm"
			/>
			<tbl:columndef
				id="actions"
				title=""
			/>
			<tbl:data style="border-right: 0; border-left: 0;">
				<tbl:headers>
					<tbl:headerrow id="row-template">
						<tbl:columnheaders />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows id="all-rows">					
				</tbl:rows>
			</tbl:data>
		</tbl:table>

		<div id="wizard-status"></div>

	</div>

</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>